<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 28/02/20
 * Time: 15.10
 */

namespace FiloBlu\Rma\Tax\Block\Sales\Order;

use Exception;
use FiloBlu\Rma\Model\Payment\ChangeSizePay;
use Magento\Framework\View\Element\Template\Context;
use Magento\Quote\Model\QuoteRepository;
use Magento\Tax\Model\Config;

/**
 *
 */
class Tax extends \Magento\Tax\Block\Sales\Order\Tax
{
    /**
     * @var QuoteRepository
     */
    private $quoteRepository;

    /**
     * Tax constructor.
     * @param Context $context
     * @param Config $taxConfig
     * @param QuoteRepository $quoteRepository
     * @param array $data
     */
    public function __construct(Context         $context,
                                Config          $taxConfig,
                                QuoteRepository $quoteRepository,
                                array           $data = [])
    {
        parent::__construct($context, $taxConfig, $data);
        $this->quoteRepository = $quoteRepository;
    }


    /**
     * @return mixed
     */
    public function getTaxAmount()
    {
        try {
            $order = $this->getOrder();
            if ($order->getQuoteId() && $order->getPayment()->getMethod() == ChangeSizePay::PAYMENT_CODE) {
                //$quote = $this->quoteRepository->get($order->getQuoteId());
                //$quoteItems = $quote->getItems();
                $tax = 0;
                foreach ($order->getItems() as $item) {
                    $tax += (float)$item->getTaxAmount();
                }
                return $tax;
            } else {
                return $this->getSource()->getTaxAmount();
            }

        } catch (Exception $exception) {
            $this->_logger->critical($exception->getMessage(), ['exception' => $exception]);
            return $this->getSource()->getTaxAmount();
        }
    }
}
